import { generateClassPrefix, WMLUIProperty, WMLCustomComponent } from '@windmillcode/wml-components-base';
import * as i0 from '@angular/core';
import { HostBinding, Input, ChangeDetectionStrategy, Component, ViewContainerRef, ViewChild, NgModule } from '@angular/core';
import { Subject, takeUntil, tap } from 'rxjs';
import * as i1 from '@windmillcode/angular-wml-components-base';
import { addCustomComponent, WMLNGXTranslatePipe, WMLNGXTranslateLoader, WMLNGXTranslateMockPipe } from '@windmillcode/angular-wml-components-base';
import * as i1$1 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i1$2 from '@ngx-translate/core';
import { TranslateModule, TranslateLoader } from '@ngx-translate/core';

// angular
// misc
class WMLSampleTabBodyComponent {
    constructor(cdref) {
        this.cdref = cdref;
        this.classPrefix = generateClassPrefix('WMLSampleTabBody');
        this.myClass = this.classPrefix(`View`);
        this.ngUnsub = new Subject();
    }
    ngOnInit() {
    }
    ngOnDestroy() {
        this.ngUnsub.next();
        this.ngUnsub.complete();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.5", ngImport: i0, type: WMLSampleTabBodyComponent, deps: [{ token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "20.0.5", type: WMLSampleTabBodyComponent, isStandalone: false, selector: "wml-tabs-zero-body-example", inputs: { props: "props" }, host: { properties: { "class": "this.myClass" } }, ngImport: i0, template: "<div [class]=\"classPrefix('MainPod')\">\r\n  <p>{{props.text | translate}}</p>\r\n</div>\r\n", styles: [":host.WMLSampleTabBodyView{display:block}\n"], dependencies: [{ kind: "pipe", type: i1.WMLNGXTranslatePipe, name: "translate" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.5", ngImport: i0, type: WMLSampleTabBodyComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wml-tabs-zero-body-example', changeDetection: ChangeDetectionStrategy.OnPush, standalone: false, template: "<div [class]=\"classPrefix('MainPod')\">\r\n  <p>{{props.text | translate}}</p>\r\n</div>\r\n", styles: [":host.WMLSampleTabBodyView{display:block}\n"] }]
        }], ctorParameters: () => [{ type: i0.ChangeDetectorRef }], propDecorators: { props: [{
                type: Input,
                args: ['props']
            }], myClass: [{
                type: HostBinding,
                args: ['class']
            }] } });

class WMLTabsZero {
    constructor(props = {}) {
        this.isChosen = false;
        this.header = {
            type: "wmlTabHeader",
            wmlTabHeader: new WMLTabHeader({
                text: [
                    new WMLUIProperty({
                        text: "Tab "
                    })
                ]
            })
        };
        this.body = new WMLCustomComponent({
            cpnt: WMLSampleTabBodyComponent,
            props: new WMLSampleTabBodyComponentProps()
        });
        Object.assign(this, {
            ...props
        });
    }
}
class WMLSampleTabBodyComponentProps {
    constructor(props = {}) {
        this.text = "my component work " + WMLSampleTabBodyComponentProps.index;
        WMLSampleTabBodyComponentProps.index++;
        Object.assign(this, {
            ...props
        });
    }
    static { this.index = 0; }
}
class WMLTabsZeroPropsUpdateTabsSubjProps {
    constructor(props = {}) {
        this.currentTable = 0;
        Object.assign(this, {
            ...props
        });
    }
}
class WMLTabsZeroProps {
    constructor(props = {}) {
        this.tabs = Array(4)
            .fill(null)
            .map((nullVal, index0) => {
            return new WMLTabsZero({
                header: {
                    type: "wmlTabHeader",
                    wmlTabHeader: new WMLTabHeader({
                        text: [
                            new WMLUIProperty({
                                text: "Tab " + index0
                            })
                        ]
                    })
                }
            });
        });
        this.updateTabsSubj = new Subject();
        this.tabChangedEvent = new Subject();
        this.setState = (val) => {
            this.updateTabsSubj.next(val);
        };
        Object.assign(this, {
            ...props
        });
    }
}
class WMLTabHeader extends WMLUIProperty {
    constructor(props = {}) {
        super();
        this.isChosenClass = "WMLTabsZeroPod0Item2";
        this.isNotChosenClass = "WMLTabsZeroPod0Item0";
        this.icon = new WMLUIProperty({
            isPresent: false
        });
        // @ts-ignore
        this.text = [];
        Object.assign(this, {
            ...props
        });
        this.updateClassString("WMLTabsZeroPod0Item0");
        this.updateClassString("WMLTabsZeroPod0Item3");
    }
    get title() {
        return this.text[0].text;
    }
}

// angular
class WMLTabBodyComponent {
    constructor(cdref) {
        this.cdref = cdref;
        this.classPrefix = generateClassPrefix('WMLTabBody');
        this.props = new WMLTabsZero();
        this.myClass = this.classPrefix(`View`);
        this.ngUnsub = new Subject();
        this.applyCustomBody = () => {
            addCustomComponent(this.customTabBody, this.props.body.cpnt, this.props.body.props);
        };
    }
    ngOnInit() {
        this.applyCustomBody();
    }
    ngOnDestroy() {
        this.ngUnsub.next();
        this.ngUnsub.complete();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.5", ngImport: i0, type: WMLTabBodyComponent, deps: [{ token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "20.0.5", type: WMLTabBodyComponent, isStandalone: false, selector: "wml-tabs-zero-body", inputs: { props: "props" }, host: { properties: { "class": "this.myClass" } }, viewQueries: [{ propertyName: "customTabBody", first: true, predicate: ["customTabBody"], descendants: true, read: ViewContainerRef, static: true }], ngImport: i0, template: "<ng-template #customTabBody></ng-template>\r\n", styles: [":host.WMLTabBodyView{display:block}\n"], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.5", ngImport: i0, type: WMLTabBodyComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wml-tabs-zero-body', changeDetection: ChangeDetectionStrategy.OnPush, standalone: false, template: "<ng-template #customTabBody></ng-template>\r\n", styles: [":host.WMLTabBodyView{display:block}\n"] }]
        }], ctorParameters: () => [{ type: i0.ChangeDetectorRef }], propDecorators: { props: [{
                type: Input,
                args: ["props"]
            }], myClass: [{
                type: HostBinding,
                args: ['class']
            }], customTabBody: [{
                type: ViewChild,
                args: ["customTabBody", { read: ViewContainerRef, static: true }]
            }] } });

// angular
class WMLTabsZeroComponent {
    constructor(cdref) {
        this.cdref = cdref;
        this.classPrefix = generateClassPrefix('WMLTabsZero');
        this.props = new WMLTabsZeroProps();
        this.myClass = this.classPrefix(`View`);
        this.ngUnsub = new Subject();
        this.listenForUpdateTabs = () => {
            return this.props.updateTabsSubj
                .pipe(takeUntil(this.ngUnsub), tap((res) => {
                this.updateTabs(res);
            }));
        };
        this.updateTabs = (res = new WMLTabsZeroPropsUpdateTabsSubjProps()) => {
            this.props.tabs.forEach((tab, index0) => {
                tab.index = index0;
                if (tab.header.type === "wmlTabHeader") {
                    tab.header.wmlTabHeader.click = this.toggleSelectedTab;
                }
                if (tab.header.type === "custom") {
                    tab.header.custom.props.click = this.toggleSelectedTab;
                }
            });
            this.toggleSelectedTab(this.props.tabs[res.currentTable]);
        };
        this.toggleSelectedTab = (targetTab) => {
            this.props.tabs.forEach((tab) => {
                if (targetTab === tab) {
                    tab.isChosen = true;
                    if (tab.header.wmlTabHeader) {
                        tab.header.wmlTabHeader.updateClassString(tab.header.wmlTabHeader.isNotChosenClass, "remove");
                        tab.header.wmlTabHeader.updateClassString(tab.header.wmlTabHeader.isChosenClass);
                    }
                }
                else {
                    tab.isChosen = false;
                    if (tab.header.wmlTabHeader) {
                        tab.header.wmlTabHeader.updateClassString(tab.header.wmlTabHeader.isChosenClass, "remove");
                        tab.header.wmlTabHeader.updateClassString(tab.header.wmlTabHeader.isNotChosenClass);
                    }
                }
            });
            this.cdref.detectChanges();
            this.props.tabChangedEvent.next(targetTab);
        };
    }
    ngOnInit() {
        this.listenForUpdateTabs().subscribe();
        this.props.updateTabsSubj.next(new WMLTabsZeroPropsUpdateTabsSubjProps());
    }
    ngOnDestroy() {
        this.ngUnsub.next();
        this.ngUnsub.complete();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.5", ngImport: i0, type: WMLTabsZeroComponent, deps: [{ token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "20.0.5", type: WMLTabsZeroComponent, isStandalone: false, selector: "wml-tabs-zero", inputs: { props: "props" }, host: { properties: { "class": "this.myClass" } }, ngImport: i0, template: "<div [class]=\"classPrefix('MainPod')\">\r\n  <section [class]=\"classPrefix('Pod0')\">\r\n    <ng-container *ngFor=\"let tab of props.tabs\">\r\n      <div\r\n      (click)=(tab.header.wmlTabHeader?.click(tab))\r\n      [class]=\"tab.header.wmlTabHeader?.class ?? classPrefix('Pod0Item0')\"\r\n      *ngIf=\"tab.header.type === 'wmlTabHeader'\">\r\n        <div *ngIf=\"tab.header.wmlTabHeader!.icon.isPresent\" [class]=\"classPrefix('Pod0Item1')\">\r\n          <p>{{tab.header.wmlTabHeader!.icon.text ?? \"\" | translate}}</p>\r\n        </div>\r\n        <label>\r\n          <span *ngFor=\"let text of tab.header.wmlTabHeader!.text\">{{text.text  ??\"\"| translate}} </span>\r\n        </label>\r\n      </div>\r\n    </ng-container>\r\n  </section>\r\n  <section [class]=\"classPrefix('Pod1')\">\r\n    <ng-container  *ngFor=\"let tab of props.tabs\">\r\n      <wml-tabs-zero-body *ngIf=\"tab.isChosen\" [props] =\"tab\"></wml-tabs-zero-body>\r\n    </ng-container>\r\n  </section>\r\n</div>\r\n", styles: [":host *{transition:none}:host.WMLTabsZeroView{display:block}:host.WMLTabsZeroView .WMLTabsZeroPod0{display:flex}:host.WMLTabsZeroView .WMLTabsZeroPod0Item0{border:.0625rem solid rgb(128,128,128);min-height:3rem;flex:1 0 auto;display:flex;justify-content:center;align-items:center;cursor:pointer}:host.WMLTabsZeroView .WMLTabsZeroPod0Item2{border-bottom:.125rem solid #EF0107;min-height:3rem;flex:1 0 auto;display:flex;justify-content:center;align-items:center}:host.WMLTabsZeroView .WMLTabsZeroPod0Item3{min-height:3rem;flex:1 0 auto;display:flex;justify-content:center;align-items:center}:host.WMLTabsZeroView .WMLTabsZeroPod0Item1{border-radius:100%;flex:0 0 2rem;height:70%;border:.0625rem solid #EF0107;margin:0 1rem 0 0}\n"], dependencies: [{ kind: "directive", type: i1$1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1$1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: WMLTabBodyComponent, selector: "wml-tabs-zero-body", inputs: ["props"] }, { kind: "pipe", type: i1.WMLNGXTranslatePipe, name: "translate" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.5", ngImport: i0, type: WMLTabsZeroComponent, decorators: [{
            type: Component,
            args: [{ selector: 'wml-tabs-zero', changeDetection: ChangeDetectionStrategy.OnPush, standalone: false, template: "<div [class]=\"classPrefix('MainPod')\">\r\n  <section [class]=\"classPrefix('Pod0')\">\r\n    <ng-container *ngFor=\"let tab of props.tabs\">\r\n      <div\r\n      (click)=(tab.header.wmlTabHeader?.click(tab))\r\n      [class]=\"tab.header.wmlTabHeader?.class ?? classPrefix('Pod0Item0')\"\r\n      *ngIf=\"tab.header.type === 'wmlTabHeader'\">\r\n        <div *ngIf=\"tab.header.wmlTabHeader!.icon.isPresent\" [class]=\"classPrefix('Pod0Item1')\">\r\n          <p>{{tab.header.wmlTabHeader!.icon.text ?? \"\" | translate}}</p>\r\n        </div>\r\n        <label>\r\n          <span *ngFor=\"let text of tab.header.wmlTabHeader!.text\">{{text.text  ??\"\"| translate}} </span>\r\n        </label>\r\n      </div>\r\n    </ng-container>\r\n  </section>\r\n  <section [class]=\"classPrefix('Pod1')\">\r\n    <ng-container  *ngFor=\"let tab of props.tabs\">\r\n      <wml-tabs-zero-body *ngIf=\"tab.isChosen\" [props] =\"tab\"></wml-tabs-zero-body>\r\n    </ng-container>\r\n  </section>\r\n</div>\r\n", styles: [":host *{transition:none}:host.WMLTabsZeroView{display:block}:host.WMLTabsZeroView .WMLTabsZeroPod0{display:flex}:host.WMLTabsZeroView .WMLTabsZeroPod0Item0{border:.0625rem solid rgb(128,128,128);min-height:3rem;flex:1 0 auto;display:flex;justify-content:center;align-items:center;cursor:pointer}:host.WMLTabsZeroView .WMLTabsZeroPod0Item2{border-bottom:.125rem solid #EF0107;min-height:3rem;flex:1 0 auto;display:flex;justify-content:center;align-items:center}:host.WMLTabsZeroView .WMLTabsZeroPod0Item3{min-height:3rem;flex:1 0 auto;display:flex;justify-content:center;align-items:center}:host.WMLTabsZeroView .WMLTabsZeroPod0Item1{border-radius:100%;flex:0 0 2rem;height:70%;border:.0625rem solid #EF0107;margin:0 1rem 0 0}\n"] }]
        }], ctorParameters: () => [{ type: i0.ChangeDetectorRef }], propDecorators: { props: [{
                type: Input,
                args: ['props']
            }], myClass: [{
                type: HostBinding,
                args: ['class']
            }] } });

let cpnts = [
    WMLTabsZeroComponent,
    WMLTabBodyComponent,
    WMLSampleTabBodyComponent
];
class WMLTabsZeroModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "20.0.5", ngImport: i0, type: WMLTabsZeroModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "20.0.5", ngImport: i0, type: WMLTabsZeroModule, declarations: [WMLTabsZeroComponent,
            WMLTabBodyComponent,
            WMLSampleTabBodyComponent], imports: [i1$2.TranslateModule, WMLNGXTranslatePipe,
            CommonModule], exports: [WMLTabsZeroComponent,
            WMLTabBodyComponent,
            WMLSampleTabBodyComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "20.0.5", ngImport: i0, type: WMLTabsZeroModule, providers: [
            { provide: WMLNGXTranslatePipe, useValue: WMLNGXTranslateMockPipe }
        ], imports: [TranslateModule.forRoot({
                defaultLanguage: 'en',
                loader: {
                    provide: TranslateLoader,
                    useFactory: () => new WMLNGXTranslateLoader(),
                }
            }),
            CommonModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "20.0.5", ngImport: i0, type: WMLTabsZeroModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        ...cpnts,
                    ],
                    imports: [
                        TranslateModule.forRoot({
                            defaultLanguage: 'en',
                            loader: {
                                provide: TranslateLoader,
                                useFactory: () => new WMLNGXTranslateLoader(),
                            }
                        }),
                        WMLNGXTranslatePipe,
                        CommonModule,
                    ],
                    exports: [
                        ...cpnts
                    ],
                    providers: [
                        { provide: WMLNGXTranslatePipe, useValue: WMLNGXTranslateMockPipe }
                    ],
                }]
        }] });

/*
 * Public API Surface of wml-tabs
 */

/**
 * Generated bundle index. Do not edit.
 */

export { WMLSampleTabBodyComponent, WMLSampleTabBodyComponentProps, WMLTabBodyComponent, WMLTabHeader, WMLTabsZero, WMLTabsZeroComponent, WMLTabsZeroModule, WMLTabsZeroProps, WMLTabsZeroPropsUpdateTabsSubjProps };
//# sourceMappingURL=windmillcode-angular-wml-tabs.mjs.map
