import { WMLUIProperty, WMLCustomComponent } from '@windmillcode/wml-components-base';
import * as rxjs from 'rxjs';
import { Subject } from 'rxjs';
import * as i0 from '@angular/core';
import { ChangeDetectorRef, ViewContainerRef } from '@angular/core';
import * as i4 from '@ngx-translate/core';
import * as i5 from '@windmillcode/angular-wml-components-base';
import * as i6 from '@angular/common';

declare class WMLTabsZero {
    constructor(props?: Partial<WMLTabsZero>);
    index: number;
    isChosen: boolean;
    header: {
        type: "custom" | "wmlTabHeader";
        wmlTabHeader?: WMLTabHeader;
        custom?: WMLCustomComponent;
    };
    body: WMLCustomComponent<any, any>;
}
declare class WMLSampleTabBodyComponentProps {
    constructor(props?: Partial<WMLSampleTabBodyComponentProps>);
    static index: number;
    text: string;
}
declare class WMLTabsZeroPropsUpdateTabsSubjProps {
    constructor(props?: Partial<WMLTabsZeroPropsUpdateTabsSubjProps>);
    currentTable: number;
}
declare class WMLTabsZeroProps {
    constructor(props?: Partial<WMLTabsZeroProps>);
    tabs: Array<WMLTabsZero>;
    readonly updateTabsSubj: Subject<void | WMLTabsZeroPropsUpdateTabsSubjProps>;
    readonly tabChangedEvent: Subject<WMLTabsZero>;
    setState: (val: any) => void;
}
declare class WMLTabHeader extends WMLUIProperty {
    constructor(props?: Partial<WMLTabHeader>);
    isChosenClass: string;
    isNotChosenClass: string;
    icon: WMLUIProperty<any, any>;
    click: (val?: any) => void;
    text: WMLUIProperty[];
    get title(): string | undefined;
}

declare class WMLTabsZeroComponent {
    cdref: ChangeDetectorRef;
    constructor(cdref: ChangeDetectorRef);
    classPrefix: (val?: string) => string;
    props: WMLTabsZeroProps;
    myClass: string;
    ngUnsub: Subject<void>;
    listenForUpdateTabs: () => rxjs.Observable<void | WMLTabsZeroPropsUpdateTabsSubjProps>;
    updateTabs: (res?: WMLTabsZeroPropsUpdateTabsSubjProps) => void;
    toggleSelectedTab: (targetTab: WMLTabsZero) => void;
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<WMLTabsZeroComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<WMLTabsZeroComponent, "wml-tabs-zero", never, { "props": { "alias": "props"; "required": false; }; }, {}, never, never, false, never>;
}

declare class WMLTabBodyComponent {
    cdref: ChangeDetectorRef;
    constructor(cdref: ChangeDetectorRef);
    classPrefix: (val?: string) => string;
    props: WMLTabsZero;
    myClass: string;
    ngUnsub: Subject<void>;
    customTabBody: ViewContainerRef;
    ngOnInit(): void;
    applyCustomBody: () => void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<WMLTabBodyComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<WMLTabBodyComponent, "wml-tabs-zero-body", never, { "props": { "alias": "props"; "required": false; }; }, {}, never, never, false, never>;
}

declare class WMLSampleTabBodyComponent {
    cdref: ChangeDetectorRef;
    constructor(cdref: ChangeDetectorRef);
    classPrefix: (val?: string) => string;
    props: WMLSampleTabBodyComponentProps;
    myClass: string;
    ngUnsub: Subject<void>;
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<WMLSampleTabBodyComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<WMLSampleTabBodyComponent, "wml-tabs-zero-body-example", never, { "props": { "alias": "props"; "required": false; }; }, {}, never, never, false, never>;
}

declare class WMLTabsZeroModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<WMLTabsZeroModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<WMLTabsZeroModule, [typeof WMLTabsZeroComponent, typeof WMLTabBodyComponent, typeof WMLSampleTabBodyComponent], [typeof i4.TranslateModule, typeof i5.WMLNGXTranslatePipe, typeof i6.CommonModule], [typeof WMLTabsZeroComponent, typeof WMLTabBodyComponent, typeof WMLSampleTabBodyComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<WMLTabsZeroModule>;
}

export { WMLSampleTabBodyComponent, WMLSampleTabBodyComponentProps, WMLTabBodyComponent, WMLTabHeader, WMLTabsZero, WMLTabsZeroComponent, WMLTabsZeroModule, WMLTabsZeroProps, WMLTabsZeroPropsUpdateTabsSubjProps };
